GAME_BG_OFF = $80
GAME_CUR_DELAY = $82
GAME_CUR_TEXT = $83
GAME_CUR_FADE = $84
GAME_BG_PTR = $85
GAME_BG_PAGE = $86
GAME_SKIP = $87
GAME_CHANGE_CNT = $88
.global NMI_CALL, reset
GAME_CHANGE = 300

wellDone:  
 jsr waitNMI
 lda #$0
 sta CNROM_CHRBANK
 lda #0
 sta PPU_MASK

 ldx #<(wellDoneTable)
 ldy #>(wellDoneTable)
 lda #$20
 sta PPU_ADDR
 lda #$00
 sta PPU_ADDR
 jsr unrle
 ldx #<(wellDoneTable)
 ldy #>(wellDoneTable)
 lda #$24
 sta PPU_ADDR
 lda #$00
 sta PPU_ADDR
 jsr unrle

 lda #$31
 jsr wellDoneTextColor
 jsr resetPPUAdr

 lda #50
 sta <GAME_CUR_DELAY
 lda #0
 sta <GAME_CUR_OFF
 sta <GAME_CUR_TEXT
 sta <GAME_CUR_FADE
 sta <GAME_BG_PTR
 sta <GAME_BG_OFF
 lda #$01
 sta <GAME_BG_OFF+1
 lda #$21
 sta <GAME_BG_PAGE

 lda #<(GAME_CHANGE)
 sta <GAME_CHANGE_CNT
 lda #>(GAME_CHANGE)
 sta <GAME_CHANGE_CNT+1

 jsr clearOAM

 lda #$3f
 sta OAM_PAGE+0
 lda #$ff
 sta OAM_PAGE+1
 sty OAM_PAGE+2
 sty OAM_PAGE+3

 lda #%00011110
 sta PPU_MASK
 jsr waitNMI
 jsr updateOAM

 ldx #<(palDone)
 ldy #>(palDone)
 jsr palFadeIn

 lda #BGM_DONE
 jsr bgmPlay

 jsr waitNMI
 jsr updateOAM

 lda #NMI_DONE
 jsr setNmiHandler

@wait:  
 jsr waitNMI
 jmp @wait


wellDoneTextColor:  
 ldx #$3f
 stx PPU_ADDR
 ldx #$0f
 stx PPU_ADDR
 sta PPU_DATA
 rts 


nmiDone:  
 pha 
 txa 
 pha 
 tya 
 pha 

 jsr updateOAM

 jsr ntscIsSkip
 lda #0
 bcc @1
 lda #1
@1:  
 sta <GAME_SKIP
 beq @draw
 jmp @noDraw
@draw:  

 ldy #0
 lda #$20
 sta PPU_ADDR
 lda <GAME_CUR_OFF
 asl
 clc 
 adc #$c2
 sta PPU_ADDR

 lda <GAME_CUR_DELAY
 beq @print
 lda <FRAME_CNT
 and #16
 beq @curBlink
 ldy #$47
@curBlink:  
 sty PPU_DATA
 lda #$20
 sta PPU_ADDR
 lda <GAME_CUR_OFF
 asl
 clc
 adc #$e2
 sta PPU_ADDR
 sty PPU_DATA
 lda <GAME_CUR_DELAY
 cmp #$fe
 bcs @noDec
 dec <GAME_CUR_DELAY
@noDec:  
 jmp @noPrint

@print:  
 lda <GAME_CUR_FADE
 bne @noPrint
 lda <FRAME_CNT
 and #1
 beq @noPrint
 lda <GAME_CUR_DELAY
 bne @noPrint
 lda <GAME_CUR_OFF
 asl
 clc 
 adc <GAME_CUR_TEXT
 tax 
 lda wellDoneText,x
 bne @noBr
 lda #$ff
 sta <GAME_CUR_DELAY
 jmp @noPrint

@noBr:  
 sta PPU_DATA
 inx
 lda wellDoneText,x
 sta PPU_DATA
 lda #$47
 sta PPU_DATA
 
 lda #$20
 sta PPU_ADDR
 lda <GAME_CUR_OFF
 asl
 clc 
 adc #$e2
 sta PPU_ADDR
 lda wellDoneText2-1,x
 sta PPU_DATA
 lda wellDoneText2,x
 sta PPU_DATA
 lda #$47
 sta PPU_DATA

 inc <GAME_CUR_OFF
@noPrint:  

 lda <GAME_CUR_DELAY
 cmp #$fe
 beq @skipH

 dec <GAME_CHANGE_CNT
 bne @skipH
 dec <GAME_CHANGE_CNT+1
 lda <GAME_CHANGE_CNT+1
 cmp #$ff
 bne @skipH

 lda <GAME_CUR_OFF
 beq @skipH
 lda <GAME_CUR_TEXT
 sec 
 adc <GAME_CUR_OFF
 clc
 adc <GAME_CUR_OFF
 sta <GAME_CUR_TEXT
 tax 
 lda wellDoneText,x
 bne @noStop
 lda #$fe
 sta <GAME_CUR_DELAY
 jmp @skipH
@noStop:  
 lda #20
 sta <GAME_CUR_FADE

 lda #<(GAME_CHANGE)
 sta <GAME_CHANGE_CNT
 lda #>(GAME_CHANGE)
 sta <GAME_CHANGE_CNT+1
@skipH:  

 lda <GAME_CUR_FADE
 beq @noFade
 lsr a
 lsr a
 tax 
 lda wellDoneFade,x
 jsr wellDoneTextColor
 dec <GAME_CUR_FADE
 lda <GAME_CUR_FADE
 bne @noFade
 lda #0
 sta <GAME_CUR_OFF
 lda #25
 sta <GAME_CUR_DELAY
 lda #$20
 sta PPU_ADDR
 lda #$c3
 sta PPU_ADDR
 lda #0
 ldx #60
@clearLine:  
 sta PPU_DATA
 dex 
 bne @clearLine
 lda #$31
 jsr wellDoneTextColor
@noFade:  

@drawColumn:  
 lda <GAME_BG_OFF
 and #15
 beq @noSkip
 jmp @noDraw
@noSkip:  
 lda <GAME_BG_OFF
 clc 
 adc #<-16
 lsr a
 lsr a
 lsr a
 and #%00011110
 clc 
 adc #$40
 sta <TEMP+1
 lda <GAME_BG_PAGE
 sta <TEMP+2
 lda #5
 sta <TEMP
 lda #1
 sta <TEMP+3
@drawCol0:  
 ldx <GAME_BG_PTR
 lda wellDoneBG,x
 and <TEMP+3
 bne @drawCol1
 ldx #$8d
 ldy #$a1
 jmp @drawCol2
@drawCol1:  
 ldx #$f8
 ldy #$f6
 lda <TEMP+1
 lsr a
 eor <TEMP
 and #1
 beq @drawCol2
 ldx #$f4
@drawCol2:  
 lda <TEMP+2
 sta PPU_ADDR
 lda <TEMP+1
 sta PPU_ADDR
 stx PPU_DATA
 inx 
 stx PPU_DATA
 lda <TEMP+2
 sta PPU_ADDR
 lda <TEMP+1
 clc 
 adc #32
 sta PPU_ADDR
 sty PPU_DATA
 iny 
 sty PPU_DATA

 lda <TEMP+1
 clc 
 adc #64
 sta <TEMP+1
 lda <TEMP+2
 adc #0
 sta <TEMP+2

 asl <TEMP+3
 dec <TEMP
 bne @drawCol0

 inc <GAME_BG_PTR
 ldx <GAME_BG_PTR
 lda wellDoneBG,x
 cmp #$ff
 bne @noDraw
 lda #0
 sta <GAME_BG_PTR
@noDraw:  

 jsr resetPPUAdr
 sta PPU_SCROLL
 sta PPU_SCROLL

 jsr FamiToneUpdate

@sprite0hit0:  
 bit PPU_STATUS
 bvs @sprite0hit0
@sprite0hit1:  
 bit PPU_STATUS
 bvc @sprite0hit1

 ldx #50
@delay0:  
 dex 
 bne @delay0

 lda #%00010100
 sta PPU_MASK
 lda #$01
 sta PPU_ADDR
 lda #$20
 sta PPU_ADDR

 inc <FRAME_CNT
 lda <FRAME_CNT
 and #%00010000
 ora #%10000000
 ora <GAME_BG_OFF+1
 sta PPU_CTRL

 lda <GAME_BG_OFF
 sta PPU_SCROLL
 lda #0
 sta PPU_SCROLL
 lda #%00011110
 sta PPU_MASK

 lda <GAME_SKIP
 bne @skip

 inc <GAME_BG_OFF
 lda <GAME_BG_OFF
 bne @noInc
 lda <GAME_BG_OFF+1
 eor #$01
 sta <GAME_BG_OFF+1
@noInc:  
 lda <GAME_BG_OFF
 cmp #16
 bne @noPageChange
 lda <GAME_BG_PAGE
 eor #$04
 sta <GAME_BG_PAGE
@noPageChange:  

@skip:  
 pla 
 tay 
 pla 
 tax 
 pla 
 rti 


wellDoneTable:  
 .incbin "welldone.rle"

wellDoneFade:  
 .byt $0c,$0c,$1c,$11,$21,$2c

wellDoneText:  
 .byt $2e,$2f,$64,$65,$2c,$2d,$00
 .byt $2e,$2f,$64,$65,$2a,$2a,$28,$29,$86,$87,$dc,$dd,$84,$85,$86,$87,$88,$89,$00
 .byt $84,$85,$86,$87,$8b,$8c,$da,$db,$d8,$d9,$2a,$2a,$86,$87,$dc,$dd,$de,$df,$00
 .byt $2e,$2f,$de,$df,$6e,$6f,$4b,$4c,$28,$29,$84,$85,$82,$83,$00,$00

wellDoneText2:  
 .byt $3e,$3f,$74,$75,$3c,$3d,$00
 .byt $3e,$3f,$74,$75,$3a,$3a,$38,$39,$96,$97,$ec,$ed,$94,$95,$96,$97,$98,$99,$00
 .byt $94,$95,$96,$97,$9b,$9c,$ea,$eb,$e8,$e9,$3a,$3a,$96,$97,$ec,$ed,$ee,$ef,$00
 .byt $3e,$3f,$ee,$ef,$7e,$7f,$5b,$5c,$38,$39,$94,$95,$92,$93,$00,$00

wellDoneBG:  
 .byt %00000000
 .byt %00001111
 .byt %00010010
 .byt %00010010
 .byt %00001100
 .byt %00000000
 .byt %00001000
 .byt %00011010
 .byt %00001101
 .byt %00011010
 .byt %00000000
 .byt %00000110
 .byt %00001000
 .byt %00001000
 .byt %00001000
 .byt %00000110
 .byt %00000000
 .byt %00010100
 .byt %00011101
 .byt %00011000
 .byt %00000000
 .byt %00010111
 .byt %00000000
 .byt %00000110
 .byt %00001000
 .byt %00001000
 .byt %00001000
 .byt %00000110
 .byt %00000000
 .byt %00011111
 .byt %00010001
 .byt %00000010
 .byt %00011100
 .byt %00010000
 .byt %00000000
 .byt %00001111
 .byt %00010010
 .byt %00010010
 .byt %00001100
 .byt %00000000
 .byt %00010000
 .byt $ff
